﻿using System.Collections.Generic;
using System.Windows.Data;
using System.ComponentModel;

namespace TestProject
{
    /// <summary>
    /// 뷰 모델
    /// </summary>
    public class ViewModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 컬렉션 뷰
        /// </summary>
        private ICollectionView collectionView;

        /// <summary>
        /// 필터 항목 리스트
        /// </summary>
        private List<FilterItem> filterItemList;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 컬렉션 뷰 - CollectionView

        /// <summary>
        /// 컬렉션 뷰
        /// </summary>
        public ICollectionView CollectionView
        {
            get
            {
                if(this.collectionView == null)
                {
                    List<SampleData> list = new List<SampleData>();

                    for(int i = 0; i < 100; i++)
                    {
                        list.Add
                        (
                            new SampleData()
                            {
                                Number1 = i,
                                Number2 = i * 10,
                                Text1   = "row " + i,
                                Text2   = "ROW " + i
                            }
                        );
                    }

                    this.collectionView = new ListCollectionView(list);
                }

                return this.collectionView;
            }
        }

        #endregion
        #region 필터 항목 리스트 - FilterItemList

        /// <summary>
        /// 필터 항목 리스트
        /// </summary>
        public List<FilterItem> FilterItemList
        {
            get
            {
                if(this.filterItemList == null)
                {
                    this.filterItemList = new List<FilterItem>()
                    {
                        new FilterItem()
                        {
                            Caption = "All items"
                        },
                        new FilterItem()
                        {
                            Caption = "Even items",
                            Filter  = (item) => { return ((SampleData)item).Number1 % 2 == 0; }
                        },
                        new FilterItem()
                        {
                            Caption = "Odd items",
                            Filter  = (item) => { return ((SampleData)item).Number1 % 2 == 1; }
                        }
                    };
                }

                return this.filterItemList;
            }
        }

        #endregion
    }
}